/* deletable.c generated by valac 0.28.0, the Vala compiler
 * generated from deletable.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2004,2005 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2012 Stefan Walter
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "seahorse-common.h"
#include <gtk/gtk.h>
#include <gio/gio.h>

typedef struct _Block2Data Block2Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _Block2Data {
	int _ref_count_;
	GMainLoop* loop;
	GAsyncResult* _result_;
};



static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void ____lambda8_ (Block2Data* _data2_, GObject* obj, GAsyncResult* res);
static void _____lambda8__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);


SeahorseDeleter* seahorse_deletable_create_deleter (SeahorseDeletable* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return SEAHORSE_DELETABLE_GET_INTERFACE (self)->create_deleter (self);
}


gboolean seahorse_deletable_can_delete (GObject* obj) {
	gboolean result = FALSE;
	GObject* _tmp0_ = NULL;
	g_return_val_if_fail (obj != NULL, FALSE);
	_tmp0_ = obj;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, SEAHORSE_TYPE_DELETABLE)) {
		GObject* _tmp1_ = NULL;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		_tmp1_ = obj;
		_tmp2_ = seahorse_deletable_get_deletable (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, SEAHORSE_TYPE_DELETABLE, SeahorseDeletable));
		_tmp3_ = _tmp2_;
		result = _tmp3_;
		return result;
	}
	result = FALSE;
	return result;
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		_g_object_unref0 (_data2_->_result_);
		_g_main_loop_unref0 (_data2_->loop);
		g_slice_free (Block2Data, _data2_);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void ____lambda8_ (Block2Data* _data2_, GObject* obj, GAsyncResult* res) {
	GAsyncResult* _tmp0_ = NULL;
	GAsyncResult* _tmp1_ = NULL;
	GMainLoop* _tmp2_ = NULL;
	g_return_if_fail (res != NULL);
	_tmp0_ = res;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data2_->_result_);
	_data2_->_result_ = _tmp1_;
	_tmp2_ = _data2_->loop;
	g_main_loop_quit (_tmp2_);
}


static void _____lambda8__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
	____lambda8_ (self, source_object, res);
	block2_data_unref (self);
}


gint seahorse_deletable_delete_with_prompt_wait (GList* objects, GtkWindow* parent, GError** error) {
	gint result = 0;
	Block2Data* _data2_;
	GMainLoop* _tmp0_ = NULL;
	gint count = 0;
	GHashTable* pending = NULL;
	GHashFunc _tmp1_ = NULL;
	GEqualFunc _tmp2_ = NULL;
	GHashTable* _tmp3_ = NULL;
	GList* _tmp4_ = NULL;
	GList* _tmp8_ = NULL;
	GError * _inner_error_ = NULL;
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_tmp0_ = g_main_loop_new (NULL, FALSE);
	_data2_->loop = _tmp0_;
	_data2_->_result_ = NULL;
	count = 0;
	_tmp1_ = g_direct_hash;
	_tmp2_ = g_direct_equal;
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, NULL, NULL);
	pending = _tmp3_;
	_tmp4_ = objects;
	{
		GList* obj_collection = NULL;
		GList* obj_it = NULL;
		obj_collection = _tmp4_;
		for (obj_it = obj_collection; obj_it != NULL; obj_it = obj_it->next) {
			GObject* _tmp5_ = NULL;
			GObject* obj = NULL;
			_tmp5_ = _g_object_ref0 ((GObject*) obj_it->data);
			obj = _tmp5_;
			{
				GHashTable* _tmp6_ = NULL;
				GObject* _tmp7_ = NULL;
				_tmp6_ = pending;
				_tmp7_ = obj;
				g_hash_table_add (_tmp6_, _tmp7_);
				_g_object_unref0 (obj);
			}
		}
	}
	_tmp8_ = objects;
	{
		GList* obj_collection = NULL;
		GList* obj_it = NULL;
		obj_collection = _tmp8_;
		for (obj_it = obj_collection; obj_it != NULL; obj_it = obj_it->next) {
			GObject* _tmp9_ = NULL;
			GObject* obj = NULL;
			_tmp9_ = _g_object_ref0 ((GObject*) obj_it->data);
			obj = _tmp9_;
			{
				GHashTable* _tmp10_ = NULL;
				GObject* _tmp11_ = NULL;
				gconstpointer _tmp12_ = NULL;
				GObject* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				SeahorseDeleter* deleter = NULL;
				GObject* _tmp17_ = NULL;
				SeahorseDeleter* _tmp18_ = NULL;
				GList* _tmp19_ = NULL;
				gboolean ret = FALSE;
				SeahorseDeleter* _tmp28_ = NULL;
				GtkWindow* _tmp29_ = NULL;
				gboolean _tmp30_ = FALSE;
				gboolean _tmp31_ = FALSE;
				SeahorseDeleter* _tmp32_ = NULL;
				GMainLoop* _tmp33_ = NULL;
				gboolean _tmp34_ = FALSE;
				SeahorseDeleter* _tmp35_ = NULL;
				GAsyncResult* _tmp36_ = NULL;
				gboolean _tmp37_ = FALSE;
				_tmp10_ = pending;
				_tmp11_ = obj;
				_tmp12_ = g_hash_table_lookup (_tmp10_, _tmp11_);
				if (((GObject*) _tmp12_) == NULL) {
					_g_object_unref0 (obj);
					continue;
				}
				_tmp13_ = obj;
				_tmp14_ = seahorse_deletable_can_delete (_tmp13_);
				if (!_tmp14_) {
					GHashTable* _tmp15_ = NULL;
					GObject* _tmp16_ = NULL;
					_tmp15_ = pending;
					_tmp16_ = obj;
					g_hash_table_remove (_tmp15_, _tmp16_);
					_g_object_unref0 (obj);
					continue;
				}
				_tmp17_ = obj;
				_tmp18_ = seahorse_deletable_create_deleter (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, SEAHORSE_TYPE_DELETABLE, SeahorseDeletable));
				deleter = _tmp18_;
				_tmp19_ = objects;
				{
					GList* x_collection = NULL;
					GList* x_it = NULL;
					x_collection = _tmp19_;
					for (x_it = x_collection; x_it != NULL; x_it = x_it->next) {
						GObject* _tmp20_ = NULL;
						GObject* x = NULL;
						_tmp20_ = _g_object_ref0 ((GObject*) x_it->data);
						x = _tmp20_;
						{
							GObject* _tmp21_ = NULL;
							GObject* _tmp22_ = NULL;
							GHashTable* _tmp23_ = NULL;
							GObject* _tmp24_ = NULL;
							gconstpointer _tmp25_ = NULL;
							_tmp21_ = x;
							_tmp22_ = obj;
							if (_tmp21_ == _tmp22_) {
								_g_object_unref0 (x);
								continue;
							}
							_tmp23_ = pending;
							_tmp24_ = x;
							_tmp25_ = g_hash_table_lookup (_tmp23_, _tmp24_);
							if (((GObject*) _tmp25_) != NULL) {
								SeahorseDeleter* _tmp26_ = NULL;
								GObject* _tmp27_ = NULL;
								_tmp26_ = deleter;
								_tmp27_ = x;
								seahorse_deleter_add_object (_tmp26_, _tmp27_);
							}
							_g_object_unref0 (x);
						}
					}
				}
				_tmp28_ = deleter;
				_tmp29_ = parent;
				_tmp30_ = seahorse_deleter_prompt (_tmp28_, _tmp29_);
				ret = _tmp30_;
				_tmp31_ = ret;
				if (!_tmp31_) {
					_g_object_unref0 (deleter);
					_g_object_unref0 (obj);
					break;
				}
				_tmp32_ = deleter;
				seahorse_deleter_delete (_tmp32_, NULL, _____lambda8__gasync_ready_callback, block2_data_ref (_data2_));
				_tmp33_ = _data2_->loop;
				g_main_loop_run (_tmp33_);
				_tmp35_ = deleter;
				_tmp36_ = _data2_->_result_;
				_tmp37_ = seahorse_deleter_delete_finish (_tmp35_, _tmp36_, &_inner_error_);
				_tmp34_ = _tmp37_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (deleter);
					_g_object_unref0 (obj);
					_g_hash_table_unref0 (pending);
					block2_data_unref (_data2_);
					_data2_ = NULL;
					return 0;
				}
				if (_tmp34_) {
					SeahorseDeleter* _tmp38_ = NULL;
					GList* _tmp39_ = NULL;
					_tmp38_ = deleter;
					_tmp39_ = seahorse_deleter_get_objects (_tmp38_);
					{
						GList* x_collection = NULL;
						GList* x_it = NULL;
						x_collection = _tmp39_;
						for (x_it = x_collection; x_it != NULL; x_it = x_it->next) {
							GObject* x = NULL;
							x = (GObject*) x_it->data;
							{
								GHashTable* _tmp40_ = NULL;
								GObject* _tmp41_ = NULL;
								gint _tmp42_ = 0;
								_tmp40_ = pending;
								_tmp41_ = x;
								g_hash_table_remove (_tmp40_, _tmp41_);
								_tmp42_ = count;
								count = _tmp42_ + 1;
							}
						}
					}
				} else {
					_g_object_unref0 (deleter);
					_g_object_unref0 (obj);
					break;
				}
				_g_object_unref0 (deleter);
				_g_object_unref0 (obj);
			}
		}
	}
	result = count;
	_g_hash_table_unref0 (pending);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return result;
}


gboolean seahorse_deletable_get_deletable (SeahorseDeletable* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return SEAHORSE_DELETABLE_GET_INTERFACE (self)->get_deletable (self);
}


static void seahorse_deletable_base_init (SeahorseDeletableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_object_interface_install_property (iface, g_param_spec_boolean ("deletable", "deletable", "deletable", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	}
}


GType seahorse_deletable_get_type (void) {
	static volatile gsize seahorse_deletable_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_deletable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SeahorseDeletableIface), (GBaseInitFunc) seahorse_deletable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType seahorse_deletable_type_id;
		seahorse_deletable_type_id = g_type_register_static (G_TYPE_INTERFACE, "SeahorseDeletable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (seahorse_deletable_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&seahorse_deletable_type_id__volatile, seahorse_deletable_type_id);
	}
	return seahorse_deletable_type_id__volatile;
}



